package com.snail.exam.s2dao.test;

import static org.seasar.framework.unit.S2Assert.assertEquals;

import java.util.List;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.seasar.extension.dataset.DataSet;
import org.seasar.extension.dataset.DataTable;
import org.seasar.framework.unit.DataAccessor;
import org.seasar.framework.unit.PreparationType;
import org.seasar.framework.unit.Seasar2;
import org.seasar.framework.unit.TestContext;

import com.snail.exam.s2dao.CustomerBean;
import com.snail.exam.s2dao.CustomerDao;

@RunWith(Seasar2.class)
public class CustomerDaoTest {

  private TestContext  ctx;

  private CustomerDao  dao;

  private DataAccessor accessor;

  public CustomerDaoTest() {

    super();

  }

  @Before
  public void before() {

    // データベースの内容を全てExcelファイルで入れ替える

    // 他に、NONE、WRITE、REPLACE を指定できる。

    ctx.setPreparationType(PreparationType.ALL_REPLACE);

  }

  @Test
  public void testFindByAddress() {

    // -- 0.テストの準備

    // S2JUnit4 によって、"$テストクラス名_$テストメソッド名.xls" ファイルに記述されている

    // 内容をデータベスに格納する。

    // (後ろにあるシートから処理されるようだ...FK制約があるときには親を後ろのシートに定義する)

    // -- 1.テスト対象の実行

    List<CustomerBean> resultList = dao.findByAddress("メル%");

    // -- 2.返値の検証

    DataSet expected = ctx.getExpected();

    // Listの比較をするときに、順番関係なくてよければ assertEqualsIngoreTableOrder()

    // 期待値ブックに入れられるのは、１シートのみ

    assertEquals("OUTPUT", expected, resultList);

    // -- 3.副作用の検証

    // このテストでは、データベースへの書き込みはやっていませんが・・・

    DataTable tbl = accessor.readDbByTable("CUSTOMER_TBL");

    DataSet xls = accessor.readXls(ctx.getTestClassShortName() + "_"
        + ctx.getTestMethodName() + "_SIDE_EFFECTS" + ".xls");

    assertEquals(xls.getTable("CUSTOMER_TBL"), tbl);

    // -- 4.テストの後処理

    // 0～3がロールバックされる(合格・不合格にかかわらず。例外が発生した場合でも)

  }

}
